#!/bin/bash
# copylibs.sh, Version 3
#
# (C) Copyright IBM Corp. 2005
#
#
# copies the binary and the libraries used to destination directory
# usage: ./copylibs.sh -f <executable|file> -d <destination directory>
#
#FAKE=echo


function getlibs {
	for i in `ldd $FILE | awk '{print $3}'`
	do
	   echo $i
	   if [[ -h $i ]]
	   then
	      echo $i is a link
	      #LINKPATH=${i%/*}
	      FILELINKEDTO=$(readlink -f $i)
              #FILELINKEDTOPATH=${FILELINKEDTO%/*}
	      echo $FILELINKEDTO
	      $FAKE cp -a --parent ${FILELINKEDTO} ${DESTINATION}
	   elif [[ -e $i ]]
	   then
	      $FAKE cp -a --parent $i ${DESTINATION}
	   fi
	done

	echo NOTE: Libraries which were loaded with libdl will not be copied.
	echo NOTE: be sure that you copy these extra.
}

###
###
# here the script starts
###
###

if [[ $# -ne 4 ]]
then
 echo "Usage: ./copylibs.sh -f <executable|file> -d <destination directory>"
 exit 1
fi


while getopts :f::d: OPT
do
   case $OPT in
       f )    if [[ ! $FILE && ${OPTARG:0:1} != '-' ]]
       	      then
       	         echo "option f is set with $OPTARG"
                 FILE=$OPTARG
       	         echo $FILE
	      else
	         echo error for option -f please check
	         exit 1
	      fi
	      ;;
       d )    if [[ ! $DESTINATION && ${OPTARG:0:1} != '-' ]]
       	      then
	         echo "option d is set with $OPTARG"
                 DESTINATION=$OPTARG
		 echo $DESTINATION
	      else
	         echo error for option -d please check
		 exit 1
	      fi
		 ;;		 
       :)     echo "no option set" ;exit 1 ;;
   esac
done

#here check if file (full qualified) exists
if [[ -e $FILE ]]
then
   if [[ $(file $FILE|grep ELF > /dev/null) -eq 0 ]]
   then
      getlibs 
      # a dynamic shared object, so get all other libs needed
   fi
   #copy file itself first check if file is a symlink
   if [[ -h $FILE ]]
   then
      FILE=$(readlink -f $FILE)
   fi
   $FAKE cp -a --parent $FILE $DESTINATION
elif [[ ! -e $FILE ]]
then
   #check if file is an executable maybe found in PATH
   FILE=$(which $FILE)
   if [[ $? -ne 0 ]]
   then
      echo File not found, exiting...
      exit 1
   else
      $FAKE cp -a --parent $FILE $DESTINATION
      getlibs
   fi
fi
exit
