#!/bin/sh

#
# xipinit.sh, Version 2
#
# (C) Copyright IBM Corp. 2002,2005
#
# /sbin/xipinit: use read only files from another file system
#
# default options

# internals
#set -v
#FAKE=echo

#mount point of xipimage
ROMOUNT=""
#name of xipimage
XIPIMAGE=""
#name of device node
RODEV=""

RODIRS="/lib,/usr/lib,/usr/X11R6/lib,/bin,/sbin,/usr/X11R6/bin,/usr/bin,"
# make sure it ends with ,
RODIRS="$RODIRS",

mount -t sysfs none /sys
if [ ! -e /sys/devices/dcssblk ]; then
  echo "xipinit: loading dcssblk module"
  /sbin/modprobe dcssblk
fi
echo $XIPIMAGE > /sys/devices/dcssblk/add

# mount ro file system to its mount point
echo "xipinit: mounting read-only segment"
$FAKE mount -t ext2 -o ro,xip "$RODEV" "$ROMOUNT"
# bind mount all ro dirs into rw filesystem
while [ -n "$RODIRS" ] ; do
  dir="${RODIRS%%,*}"
  RODIRS="${RODIRS#*,}"
  test -d "$dir" || continue
  echo "xipinit: binding directory" $dir
  $FAKE mount --bind "$ROMOUNT/$dir" "$dir"
done
umount /sys

# run real init
$FAKE exec /sbin/init "$@"
